/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/


#include <windows.h>

#include "seamless3d.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"
#include "resource.h"

extern double g_time;
bool g_dontCloseMenu = false;

void MenuItem::paintHoverBlister(){
	int dstWidth=win.size.x;
	int dstHeight=win.size.y;
	int* dstPix=win.pixBuf.getArray();

	paintColorSweepForCurvedBar(&iconSrcBuf[(iconSrcBufCY-1-25)*480+470], &iconSrcBuf[(iconSrcBufCY-1-25)*480+471], dstPos.x+6, dstPos.y, Vec2i(bSize.x-15, 24), dstWidth, dstHeight, dstPix);
	pasteSprite2( dstPos.x, dstPos.y, 461, 25, dstWidth, dstHeight, iconSrcBufCX, iconSrcBufCY, 10, 24, dstPix);
	pasteSprite2( dstPos.x+bSize.x-9, dstPos.y, 471, 25, dstWidth, dstHeight, iconSrcBufCX, iconSrcBufCY, 9, 24, dstPix);
}
void MenuItem::commonPaintButton(){
	int dstWidth=win.size.x;
	int dstHeight=win.size.y;
	int* dstPix=win.pixBuf.getArray();

	if(iconSize.x){
		pasteSprite2(dstPos.x+((24-iconSize.x)>>1), dstPos.y+((bSize.y-iconSize.y)>>1), srcPos.x, srcPos.y, win.size.x, win.size.y, iconSrcBufCX, iconSrcBufCY, iconSize.x, iconSize.y, win.pixBuf.getArray());
	}
	drawText2(str=label, 0, Vec2i(28,13) + dstPos, win.size.x, win.size.y, win.pixBuf.getArray());
}
void MenuItem::paint(){
	commonPaintButton();
}
void BranchMenuItem::paint(){
	commonPaintButton();
	pasteSprite2(dstPos.x+win.size.x-10, dstPos.y+8, branchMenuArrow_x, branchMenuArrow_y, win.size.x, win.size.y, iconSrcBufCX, iconSrcBufCY, 4, 7, win.pixBuf.getArray());
}
void Seperator::paint(){
	drawHorizontalLine2(0x808080, dstPos.y+1, 0, win.size.x, win.size.x, win.size.y, win.pixBuf.getArray()); 
}
void BranchMenuItem::action(){
	g_dontCloseMenu=true;
	removeTypeFromList<DownButton>(g_callBackList);
	removeTypeFromList<Button>(g_callBackList);
	g_callBackList+=this;
}
void Seperator::action(){
	g_dontCloseMenu=true;
	removeTypeFromList<DownButton>(g_callBackList);
	removeTypeFromList<Button>(g_callBackList);
	g_callBackList+=this;
}
void MenuItem_::action(){
	removeTypeFromList < DownButton>(g_callBackList);
	void (*localFunction)() = function; //move into local variables so that this (the menu) can be discarded
	Window::removeMenu();
	localFunction();
}
void MenuItem_int::action(){
	removeTypeFromList < DownButton>(g_callBackList);
	void (*localFunction)(int) = function;	//move into local variables so that this (the menu) can be discarded
	int localPar=par;
	Window::removeMenu();
	localFunction(localPar);
}
void MenuItem_int_int::action(){
	removeTypeFromList < DownButton>(g_callBackList);
	void (*localFunction)(int, int) = function;	//move into local variables so that this (the menu) can be discarded
	int localParA=parA;
	int localParB=parB;
	Window::removeMenu();
	localFunction(localParA, localParB);

//	g_callBackList+=&g_cleanUpMenu;
}
void BranchMenuItem::doCallBack(){//while hover

	if(g_time > beginHoverTime+.25 && open == false){
		Window::removeAllAbove(&win);

//		removeTypeFromList<BranchMenuItem>(g_callBackList);
		open = true;
		menuPtr->autoSizeAndStuff();
		win.openedBranchItem=this;


		Rect rect; getClientRect(rect);

		const int inABit=6;

		Vec2i menuPos = win.pos + dstPos + Vec2i(win.size.x-inABit, -2);

		if(menuPos.x + menuPtr->size.x > rect.right){
			menuPos.x-=win.size.x + menuPtr->size.x - inABit * 2;
			if(menuPos.x < 0){
				menuPos.x = 0;
			}
		}
		if(menuPos.y + menuPtr->size.y > rect.bottom){
			menuPos.y-=menuPtr->size.y - bSize.y - 2;
			if(menuPos.y < 0){
				menuPos.y = 0;
			}
		}
		menuPtr->pos=menuPos;

		//menuPtr->pos=Vec2i(win.pos+dstPos+Vec2i(bSize.x,-2));
	}
}
bool BranchMenuItem::onHoverMove(const Vec2i ptCursor){
	if( ptCursor >= dstPos && ptCursor < dstPos + bSize){

//		Window::removeAllAbove(&win);

//		removeTypeFromList < BranchMenuItem>(g_callBackList);
//		g_callBackList+=this;
//		win.paint();
		return true;
	}
	else{
		//open=false;
		//Window::removeToolTip();
		removeTypeFromList < BranchMenuItem>(g_callBackList);
		return false;
	}
}
bool MenuItem::onHoverMove(const Vec2i ptCursor){
	if( ptCursor >= dstPos && ptCursor < dstPos + bSize){

		//Window::removeAllAbove(&win);

		//removeTypeFromList < BranchMenuItem>(g_callBackList);
		//g_callBackList+=this;
		//win.paint();
		return true;
	}
	else{
		//open=false;
		//Window::removeToolTip();
		removeTypeFromList < MenuItem>(g_callBackList);
		return false;
	}
}
int MenuItem::getIndex(const M_<Ptr<MenuItem> >& list)const{
	for(int i=list.length; --i>=0;){
		if(this==list[i]){
			return i;
		}
	}
	return -1;
}
MenuItem::MenuItem(String i_label, Menu& i_win, bool i_tick):
	Button(i_win),
	win(i_win),
	label(i_label),
	tick(i_tick)
{}
MenuItem::MenuItem(Vec2i i_iconSize, Vec2i i_srcPos, Menu& i_win, bool i_tick):
	Button(i_srcPos, i_win),
	win(i_win),
	iconSize(i_iconSize),
	label(0),
	tick(i_tick)
{}
MenuItem::MenuItem(Vec2i i_iconSize, Vec2i i_srcPos, String i_label, Menu& i_win, bool i_tick):
	Button(i_srcPos, i_win),
	win(i_win),
	iconSize(i_iconSize),
	label(i_label),
	tick(i_tick)
{}
MenuItem::MenuItem(Vec2i i_iconSize, Vec2i i_srcPos, String i_label, int i_command, Menu& i_win, bool i_tick):
	Button(i_srcPos, i_command, i_win),
	win(i_win),
	iconSize(i_iconSize),
	label(i_label),
	tick(i_tick)
{}
MenuItem::MenuItem(Vec2i i_iconSize, Vec2i i_srcPos, int i_command, Menu& i_win, bool i_tick):
	Button(i_srcPos, i_command, i_win),
	win(i_win),
	iconSize(i_iconSize),
	label(0),
	tick(i_tick)
{}
